void draw()
{
  if (mode == 0)
  {
    background(134, 172, 245);
    dirt_texture();
    imageMode(CENTER);
    image(ostrich_look, width / 2, 220 - depth); 
    image(shop, width - 150, 270 - depth);
    textFont(stempel);
    textAlign(CENTER);
    fill(255);
    if(!developer)
    {
    text("A game made by Kevin De Keyser for Ludum Dare 29", width / 2, 50);
    }
    if(developer)
    {
      text("A game made by Kevin De Keyser for Ludum Dare 29 - DEV-Version", width / 2, 50);
    }
    fill(0);
    if (mouseY < 460 && mouseX > 720)
    {
      if (mousePressed)
      {
        mode = 4;
      }
    }
    if (frameCount % 20 < 10)
    {
      image(space, width / 2, 500);
    }

    if (keys[4] == true)
    {
      mode = 1;
    }
  }
  else if (mode == 1)
  {
    background(134, 172, 245);
    dirt_texture();
    imageMode(CENTER);
    image(ostrich_head, width / 2, 220 - depth); 
    image(shop, width - 150, 270 - depth);

    if (keys[4] == true)
    {
      mode = 1;
    }

    depth += 4;

    helmetEquipped = helmetOn;
    invincible = 0;
  }
  else if (mode == 2) //PLAY MODE !! MUSIC
  {
    background(134, 172, 245);
    dirt_texture();
    imageMode(CENTER);
    _head();
    _obstacles();
    _gui();

    if (invincible > 0)
    {
      invincible--;
    }

    if (weaponCooldown > 0 && samuraiOn == true)
    {
      weaponCooldown--;
    }
    else
    {
      keys[4] = false;
    }
    depth += 4;
  }
  else if (mode == 3)
  {
    _reset();
    mode = 0;
  }
  else if (mode == 4)
  {
    _shop();
  }

  if (shoutBoxCooldown > 0)
  {
    _shoutBox();
  }

  if (released && weaponSamurai)
  {
    if (bullets[cBullet].dead == true)
    {
      bullets[cBullet] = new bullet(2 + x, y + 55, (atan2(mouseY - (y + 55), mouseX - (x + 10))), cBullet, false);
      cBullet++;
      if (cBullet == 10)
      {
        cBullet = 9;
      }
    }
  }
  
  if(developer)
  {
    println(bossAY);
  }
  released = false;



  ellipseMode(CENTER);
  noFill();
  stroke(255);
  ellipse(mouseX, mouseY, 10, 10);
  line(mouseX + 5, mouseY + 5, mouseX - 5, mouseY - 5);
  line(mouseX + 5, mouseY - 5, mouseX - 5, mouseY + 5);
  stroke(0);
}

