void _obstacles()
{
  for (int i = 0; i < coins.length; i++)
  {
    coins[i].display();
  }
  for (int i = 0; i < stoneGalore.length; i++)
  {
    stoneGalore[i].display();
  }
  for (int i = 0; i < moles.length; i++)
  {
    moles[i].display();
  }

  for (int i = 0; i < bullets.length; i++)
  {
    bullets[i].display();
  }

  _bossA();
  _dracula();

  if (boulderDifficulty > 1400)
  {
    boulderDifficulty = (int)(5000 - (metres*5));
  }
}

class stone
{
  int stoneX;
  int stoneY;
  int stone_ID;
  int stone_type;
  stone(int cx, int cy, int ctype, int cID)
  {
    stoneX = cx;
    stoneY = cy;
    stone_ID = cID;
    stone_type = ctype;
    if (depth > 45000)
    {
      stone_ID = 0;
    }
  }

  void display()
  {
    stoneY -= 4;
    if (stoneY < height + 200)
    {
      if (stone_type == 0)
      {
        imageMode(CENTER);
        image(boulder, stoneX, stoneY);

        if (dist(stoneX, stoneY, x, y) < 85 && invincible == 0)
        {
          if (helmetEquipped)
          {
            helmetEquipped = false;
            invincible = 100;
          }
          else
          {
            if (frameCount % 20 < 5) message = "Stoned!\nNo pun\nintended.";
            else if (frameCount % 20 < 10) message = "You hit\nrock bottom!";
            else if (frameCount % 20 < 15) message = "I'm ashamed\nto say more\nbad jokes...";
            else if (frameCount % 20 < 20) message = "You got\nbouldered!";
            shoutBoxCooldown = 400;
            mode = 3;
            /*
            if (jsMode == true && javascript != null )
             {
             playSound3();
             }
             */
          }
          //SOUND
        }
      }

      else if (stone_type == 1)
      {
        imageMode(CENTER);
        image(carton, stoneX, stoneY);

        if (dist(stoneX, stoneY, x, y) < 110 && invincible == 0) //CHANGE???
        {
          if (helmetEquipped)
          {
            helmetEquipped = false;
            invincible = 100;
          }
          else
          {
            if (frameCount % 20 < 5) message = "Crated!";
            else if (frameCount % 20 < 10) message = "I'm sure\nthe box\nloved you!";
            else if (frameCount % 20 < 15) message = "Seriously...\nYou got\nkilled by\na square...";
            else if (frameCount % 20 < 20) message = "Isn't brown\nattractive?";
            shoutBoxCooldown = 400;
            mode = 3;
            /*
            if (jsMode == true && javascript != null )
             {
             playSound3();
             }
             */
          }
          //SOUND
        }
      }

      if (stoneY < -200)
      {
        stoneGalore[stone_ID] = new stone((int)(random(50, width - 50)), (int)(random(1000, boulderDifficulty)), (int)(random(0, 2)), stone_ID);
      }
    }
  }
}


class mole
{
  int moleX;
  int moleY;
  float moleAngle;
  int mole_ID;
  mole(int cX, int cY, int c_ID)
  {
    moleX = cX;
    moleY = cY;
    mole_ID = c_ID;
  }

  void display()
  {
    moleY -= 4;
    moleAngle = atan2(y - moleY, x - moleX);
    moleX = (int)(moleX+cos(radians(moleAngle * 50))*4);

    if (((moleX < 0 || moleX > width) &&(moleY < 0 || moleY > height)) == false)
    {
      moleY = (int)(moleY+sin(radians(moleAngle * 50))*3);
    }
    imageMode(CENTER);
    pushMatrix();
    translate(moleX, moleY);
    rotate(radians(moleAngle * 50) + 135);

    if (frameCount % 20 < 5)
    {
      image(mole1, 0, 0);
    }
    else if (frameCount % 20 < 10)
    {
      image(mole2, 0, 0);
    }
    else if (frameCount % 20 < 15)
    {
      image(mole3, 0, 0);
    }
    else if (frameCount % 20 < 20)
    {
      image(mole2, 0, 0);
    }
    popMatrix();

    if (dist(moleX, moleY, x, y) < 50 && invincible == 0) //CHANGE???
    {
      if (weaponCooldown > 70)
      {
        coins[0] = new coin((int)(random(moleX - 150, moleX + 150)), (int)(random(moleY - 150, moleY + 150)), coins[0].value, 0);
        coins[1] = new coin((int)(random(moleX - 150, moleX + 150)), (int)(random(moleY - 150, moleY + 150)), coins[1].value, 1);
        coins[2] = new coin((int)(random(moleX - 150, moleX + 150)), (int)(random(moleY - 150, moleY + 150)), coins[2].value, 2);
        coins[3] = new coin((int)(random(moleX - 150, moleX + 150)), (int)(random(moleY - 150, moleY + 150)), coins[3].value, 3);
        moles[mole_ID] =  new mole((int)(random(-500, width + 500)), (int)(random(1000, 5000)), mole_ID);
      }
      else {
        if (helmetEquipped)
        {
          helmetEquipped = false;
          invincible = 100;
          moles[mole_ID] =  new mole((int)(random(-500, width + 500)), (int)(random(1000, 5000)), mole_ID);
        }
        else
        {
          if (frameCount % 20 < 5) message = "Mole\nin one!!\n\n\nUhgghhh...\nBad Jokes...";
          else if (frameCount % 20 < 10) message = "Cute\nhe wanted\nto come\ncloser!\n\n\nAn then\nyou died.";
          else if (frameCount % 20 < 15) message = "Mole is sniffling.";
          else if (frameCount % 20 < 20) message = "Yeah..\nDied again.\nFrom an oversized\nMole.";
          shoutBoxCooldown = 200;
          mode = 3;
          /*
          if (jsMode == true && javascript != null )
          {
            playSound3();
          }
          */
        }
      }
      //SOUND
    }


    if (moleY < -200)
    {
      moles[mole_ID] =  new mole((int)(random(-500, width + 500)), (int)(random(1000, 5000)), mole_ID);
    }
  }
}



int bossAX;
int bossAY;
int bossAHealth;
float bossAngle = 0;
int chargeCooldown;
float extraAngle = 0;


void _bossA()
{

  //charge Attack
  imageMode(CENTER);
  if (bossAHealth > 0)
  {
    if (bossAY < height + 300)
    {
      pushMatrix();
      translate(bossAX, bossAY);
      rotate(radians(bossAngle * 50) + 135);
      noTint();
      if ((chargeCooldown < 50) && frameCount % 10 < 5)
      {
        tint(255, 0, 0);
      }
      if (frameCount % 20 < 5) image(boss1, 0, 0);
      else if (frameCount % 20 < 10) image(boss2, 0, 0);
      else if (frameCount % 20 < 15) image(boss3, 0, 0);
      else if (frameCount % 20 < 20) image(boss4, 0, 0);
      noTint();
      popMatrix();

      for (int i = 0; i < stoneGalore.length; i++)
      {
        if (dist(bossAX, bossAY, stoneGalore[i].stoneX, stoneGalore[i].stoneY) < 150)
        {
          stoneGalore[i] = new stone((int)(random(50, width - 50)), (int)(random(1000, boulderDifficulty)), (int)(random(0, 2)), i);
        }
      }
      fill(255);
      rect((width / 2) - 100, height - 70, bossAHealth * 4, 30);
      fill(0);
      textFont(stempel);
      textAlign(CENTER);
      text("Health of the Driller: "+bossAHealth+ " / 50", (width / 2), height - 50);
      if (chargeCooldown < 1)
      {
        chargeCooldown = 500;
      }
      chargeCooldown--;
    }


    if ((dist(x, y, (int)(bossAX+cos(radians(bossAngle * 50))*100), (int)(bossAY+sin(radians(bossAngle * 100))*50)) < 120 && weaponCooldown < 50) || (weaponCooldown > 49 && dist(x, y, (int)(bossAX+cos(radians(bossAngle * 50))*100), (int)(bossAY+sin(radians(bossAngle * 100))*50)) < 70))
    {
      if (helmetEquipped)
      {
        helmetEquipped = false;
        invincible = 100;
      }
      else
      {
        message = "Wrecked\n\nBuy upgrades\nto win!!!";
        shoutBoxCooldown = 200;
        mode = 3;
        /*
        if (jsMode == true && javascript != null )
        {
          playSound3();
        }
        */
      }
    }

    if (dist(bossAX+cos(radians(extraAngle * 50))*100, bossAY+sin(radians(extraAngle * 50))*100, x, y) < 200 && weaponCooldown > 70)
    {
      bossAHealth--;
    }



    if (bossAY > height- 20)
    {
      bossAY -= 4;
      chargeCooldown = 0;
    }
    else
    {
      if (chargeCooldown > 300)
      {
        if (((cos(radians(bossAngle * 50)) < 0 && bossAX < 20) || (cos(radians(bossAngle * 50)) > 0 && bossAX > width - 20)) == false) //IMPORTANT FIX
        {
          bossAX = (int)(bossAX+cos(radians(bossAngle * 50))*4);
        }
        if (((sin(radians(bossAngle * 50)) < 0 && bossAY < 20) || (sin(radians(bossAngle * 50)) > 0 && bossAY > width - 20)) == false)
        {
          bossAY = (int)(bossAY+sin(radians(bossAngle * 50))*4);
        }
      }
      else
      {
        if (chargeCooldown > 50)
        {
          bossAngle = atan2(y - bossAY, x - bossAX);
          extraAngle = atan2(bossAY - y, bossAX - x);
        }
      }
    }
  }
}





float draculaX;
float draculaY;
int flyToX = 500;
int flyToY = 500;
float draculaAngle = 0;
int flapCount = 0;
boolean flapDir = false;
int draculaCountdown = 0;
float draculaHealth;

void _dracula()
{
  if (draculaY < height + 300)
  {
    imageMode(CENTER);



    pushMatrix();
    translate(draculaX, draculaY);
    if (x > draculaX) scale(-1, 1);
    rotate(radians(flapCount));
    image(wing, 70, - 30);
    scale(-1, 1);
    rotate(radians(2 * flapCount));
    image(wing, 50, 0);
    popMatrix();
    pushMatrix();
    translate(draculaX, draculaY);
    if (x > draculaX) scale(-1, 1);
    image(dracula, 0, 0);

    popMatrix();

    if (draculaY < height - 50)
    {
      if (frameCount % 500 == 0)
      {
        draculaCountdown = 360;
        draculaAngle = int(atan2(draculaY - y, draculaX - x) * 50);
      }
    }
    if (draculaCountdown != 0)
    {
      draculaCountdown--; 
      draculaAngle++;

      strokeWeight(10);
      stroke(120, 0, 0);
      line(draculaX, draculaY, draculaX+cos(radians(draculaAngle))*10000, draculaY+sin(radians(draculaAngle))*10000);
      stroke(0);
      strokeWeight(1);


      if (dist(x, y, draculaX+cos(radians(draculaAngle))*dist(draculaX, draculaY, x, y), draculaY+sin(radians(draculaAngle))*dist(draculaX, draculaY, x, y)) < 20 && invincible < 1)
      {
        if (helmetEquipped)
        {
          helmetEquipped = false;
          invincible = 100;
        }
        else
        {
          message = "Tasered!";
          shoutBoxCooldown = 200;
          mode = 3;
          /*
          if (jsMode == true && javascript != null )
          {
            playSound3();
          }
          */
        }
      }
    }

    draculaX = (draculaX+cos(radians(atan2(flyToY - draculaY, flyToX - draculaX) * 50))*5);
    draculaY = (draculaY+sin(radians(atan2(flyToY - draculaY, flyToX - draculaX) * 50))*5);
    if (dist(draculaX, draculaY, flyToX, flyToY) < 50)
    {
      flyToX = int(random(50, width - 50));
      flyToY = int(random(50, height - 50));
    }
    fill(255);
    rect((width / 2) - 100, height - 70, draculaHealth, 30);
    fill(0);
    textFont(stempel);
    textAlign(CENTER);
    text("Health of Shoopdracula: "+int(draculaHealth)+ " / 200", (width / 2), height - 50);


    if (dist(draculaX, draculaY, x, y) < 200 && weaponCooldown > 70)
    {
      bossAHealth -= 0.2;
    }

    if (flapCount > 45 || flapCount < -45)
    {
      flapDir = !flapDir;
    }
    if (flapDir) flapCount+=4;
    else {
      flapCount-=4;
    }
  }
  if (draculaY > height - 100)
  {
    draculaY -= 4;
  }
}

