void _head()
{
  if (((cos(radians(angle)) < 0 && x < 20) || (cos(radians(angle)) > 0 && x > width - 20)) == false)
  {
    x = (int)(x+cos(radians(angle))*6);
  }
  y = (int)(y+sin(radians(angle))*6);
  if (y > height - 200)
  {
    y-=2;
  }
  y -= 4;
  if (keys[1] == true)
  {
    angle -= 2;
  }
  if (keys[3] == true)
  {
    angle += 2;
  }
  angle %= 360;
  imageMode(CORNER);

  if (neckCountMin > neckCountMax)
  {
    for (int i = 0; i < neckCountMax; i++)
    {
      pushMatrix();
      translate(neckX[i], neckY[i]);
      rotate(radians(neckAngle[i] + 270));
      if (scarfOn)
      {
        image(scarf, 0, 0);
      }
      else
      {
        image(neck, 0, 0);
      }
      popMatrix();
      neckY[i] -=4;
    }

    for (int i = neckCountMin; i < 500; i++)
    {
      pushMatrix();
      translate(neckX[i], neckY[i]);
      rotate(radians(neckAngle[i] + 270));
      if (scarfOn)
      {
        image(scarf, 0, 0);
      }
      else
      {
        image(neck, 0, 0);
      }
      popMatrix();
      neckY[i] -=4;
    }
  }
  for (int i = neckCountMin; i < neckCountMax; i++)
  {
    pushMatrix();
    translate(neckX[i], neckY[i]);
    rotate(radians(neckAngle[i] + 270));
    if (scarfOn)
    {
      image(scarf, 0, 0);
    }
    else
    {
      image(neck, 0, 0);
    }
    popMatrix();
    neckY[i] -=4;
  }


  neckX[(neckCountMax)%500] = x;
  neckY[(neckCountMax)%500] = y;
  neckAngle[(neckCountMax)%500] = (int)(angle);
  neckCountMax++;
  neckCountMin++;

  if (neckCountMax == 500)
  {
    neckCountMax = 0;
  }
  if (neckCountMin == 500)
  {
    neckCountMin = 0;
  }

  if ((invincible > 0 && frameCount % 10 < 5) || invincible == 0)
  {
    if (helmetEquipped == false)
    {
      pushMatrix();
      translate(x, y);
      rotate(radians(angle + 270));
      if (samuraiOn)
      {
        if (weaponCooldown > 70)
        {
          image(samurai, 10, 30);
        }
        else
        {
          image(samurai, 10, 10);
        }
      }
      image(head, 0, 0);
      if (weaponSamurai)
      {
        if (developer && keys[0] == true)
        {
          println("x: "+x +" y: "+y+ " px "+ mouseX+" py "+ mouseY);
        }
        translate(17, 30);
        strokeWeight(2);
        line(-15, 20, -15 + cos(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30, 20 + sin(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30);
        strokeWeight(1);
        rotate(radians(90));
        image(gun, 0, 0);
      }
      popMatrix();
    }
    else
    {
      pushMatrix();
      translate(x, y);
      rotate(radians(angle + 270));
      if (samuraiOn)
      {
        if (weaponCooldown > 70)
        {
          image(samurai, 10, 30);
        }
        else
        {
          image(samurai, 10, 10);
        }
      }
      image(head_military, 0, 0);
      if (weaponSamurai)
      {
        if (developer && keys[0] == true)
        {
          println("x: "+x +" y: "+y+ " px "+ mouseX+" py "+ mouseY);
        }
        translate(17, 30);
        strokeWeight(2);
        line(-15, 20, -15 + cos(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30, 20 + sin(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30);
        strokeWeight(1);
        rotate(radians(90));
        image(gun, 0, 0);
      }
      popMatrix();

      pushMatrix();
      translate(x, y);
      rotate(radians(angle + 270));
      if (samuraiOn)
      {
        if (weaponCooldown > 70)
        {
          image(samurai, 10, 30);
        }
        else
        {
          image(samurai, 10, 10);
        }
      }
      image(head_military, 0, 0);
      if (weaponSamurai)
      {
        if (developer && keys[0] == true)
        {
          println("x: "+x +" y: "+y+ " px "+ mouseX+" py "+ mouseY);
        }
        translate(17, 30);
        strokeWeight(2);
        line(-15, 20, -15 + cos(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30, 20 + sin(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30);
        strokeWeight(1);
        rotate(radians(90));
        image(gun, 0, 0);
      }
      popMatrix();
    }
  }
}



void dirt_texture()
{
  imageMode(CORNER);

  if (400 - depth > -400)
  {
    for (int j = 0; j < 8; j++)
    {
      for (int i = 0; i < 8; i++)
      {
        image(dirt, i * 128, (528 - depth) + (j * 128));
      }
    }
    for (int i = 0; i < 8; i++)
    {
      image(grass, i * 128, 400 - depth);
    }
    imageMode(CENTER);
    image(logo, width / 2, 800 - depth);
  }
  else
  {
    if (mode == 1) {
      x = width / 2;
      y = height / 4;
      angle = 90;
      mode = 2;
      /*
      if (jsMode == true && javascript != null )
      {
        playSound0();
      }
      */
    }
    for (int j = 0; j < 8; j++)
    {
      if (depth + j * 64< 5000)
      {
        for (int i = 0; i < 8; i++)
        {

          image(dirt, i * 128, (j * 128) + (400 - depth) % 256);
        }
      }
      else if (depth + j *64 < 20000)
      {
        for (int i = 0; i < 8; i++)
        {

          image(dirt_stone, i * 128, (j * 128) + (400 - depth) % 256);
        }
      }
      else if (depth + j * 128 < 50000)
      {
        for (int i = 0; i < 8; i++)
        {
          image(stone_img, i * 128, (j * 128) + (400 - depth) % 256);
        }
      }
      else if (depth + j * 128 >= 50000 && depth + j * 128 <= 80000)
      {
        for (int i = 0; i < 8; i++)
        {
          image(lava_rock, i * 128, (j * 128) + (400 - depth) % 256);
        }
      }
      else if (depth + j * 128 > 80000)
      {
        for (int i = 0; i < 8; i++)
        {
          image(lava, i * 128, (j * 128) + (400 - depth) % 256);
        }
      }
    }
  }
}

