//import java.math.*; BBBBBBIIIIIIIGGGGGG INNNNTTTTEEEEGGGGER

interface JavaScript {
  void playSound0();
  void playSound1();
  void playSound2();
  void playSound3();
}
void bindJavascript(JavaScript js) {
  javascript = js;
}
JavaScript javascript;

/* @pjs preload="ostrich_headed.png,ostrich_looking.png,dirt.png, grass.png, stone_dirt.png, stone.png, lava.png, head.png, head_alert.png, neck.png, logo.png, boulder.png, space.png, shop.png, head_military.png,helmet.png,carton.png, lava_rock.png, mole1.png, mole2.png, mole3.png, samurai.png, gun.png, boss1.png, boss2.png, boss3.png, boss4.png, disco_ball.png, scarf.png, scarf_shop.png, shoopdracula.png, wing.png"; */



boolean jsMode = true;
boolean developer = false;

PFont font;
PFont stempel;

PImage ostrich_head;
PImage ostrich_look;
PImage dirt;
PImage grass;
PImage dirt_stone;
PImage stone_img;
PImage lava_rock;
PImage lava;
PImage head;
PImage head_alert;
PImage neck;
PImage logo;
PImage boulder;
PImage space;
PImage shop;
PImage carton;
PImage mole1;
PImage mole2;
PImage mole3;
PImage boss1;
PImage boss2;
PImage boss3;
PImage boss4;
PImage disco;
PImage dracula;
PImage wing;
PImage scarf;
PImage scarf_shop;
//shop items
PImage head_military;
PImage helmet;
PImage samurai;
PImage gun;

float metres;

int x;
int y;
float angle;

int neckX[];
int neckY[];
int neckAngle[];
int neckCountMin;
int neckCountMax;

int shoutBoxCooldown;

boolean released = false;

double balance; // BIG_INTEGER PORT!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

int boulderDifficulty = 10000;

int mode;
float depth;

boolean keys[];

stone[] stoneGalore;
int stoneCount;

coin[] coins;
int coinCount;

bullet[] bullets;
int cBullet;

mole[] moles;
int moleCount;

String message;
boolean helmetEquipped = false;
boolean bossing;
int invincible;
int weaponCooldown;
//shoItems
boolean helmetOn = false;
boolean samuraiOn = false;
boolean weaponSamurai = false;
boolean scarfOn = false;


void setup()
{
  size(1024, 768);

  noCursor();

  if (jsMode)
  {
    font = createFont("HelveticaNeue", 24);
    stempel = createFont("ComicSansMS", 16);
  }
  else
  {
    font = loadFont("HelveticaNeue-24.vlw");
    stempel = loadFont("Stempel-16.vlw");
  }
  textFont(font);

  ostrich_head = loadImage("ostrich_headed.png");
  ostrich_look = loadImage("ostrich_looking.png");
  dirt = loadImage("dirt.png");
  grass = loadImage("grass.png");
  dirt_stone = loadImage("stone_dirt.png");
  stone_img = loadImage("stone.png");
  head = loadImage("head.png");
  head_alert = loadImage("head_alert.png");
  neck = loadImage("neck.png");
  logo = loadImage("logo.png");
  boulder = loadImage("boulder.png");
  space = loadImage("space.png");
  shop = loadImage("shop.png");
  head_military = loadImage("head_military.png");
  helmet = loadImage("helmet.png");
  carton = loadImage("carton.png");
  lava_rock = loadImage("lava_rock.png");
  mole1 = loadImage("mole1.png");
  mole2 = loadImage("mole2.png");
  mole3 = loadImage("mole3.png");
  samurai = loadImage("samurai.png");
  gun = loadImage("gun.png");
  boss1 = loadImage("boss1.png");
  boss2 = loadImage("boss2.png");
  boss3 = loadImage("boss3.png");
  boss4 = loadImage("boss4.png");
  disco = loadImage("disco_ball.png");
  scarf = loadImage("scarf.png");
  scarf_shop = loadImage("scarf_shop.png");
  lava = loadImage("lava.png");
  dracula = loadImage("shoopdracula.png");
  wing = loadImage("wing.png");
  
  bossing = false;

  message = "Welcome !!";
  shoutBoxCooldown = 100;

  mode = 0;

  balance = 0;
  
  coinCount = 20;
  stoneCount = 10;
  moleCount = 3;

  keys = new boolean[5];
  for (int i = 0; i < keys.length; i++)
  {
    keys[i] = false;
  }
  _reset();
}


void _reset()
{
  depth = 0;

  neckX = new int[500];
  neckY = new int[500];
  neckAngle = new int[500];
  neckCountMax = 0;
  neckCountMin = 250;
  metres = 10;
  cBullet = 0;

  for (int i = 0; i < 500; i++)
  {
    neckX[i] = -200;
    neckY[i] = -200;
    neckAngle[i] = 0;
  }
  stoneGalore = new stone[stoneCount];
  for (int i = 0; i < stoneGalore.length; i++)
  {
    int ta = (int)random(50, width - 50);
    int tb = (int)random(1000, boulderDifficulty);
    int tc = (int)random(0, 2);
    stoneGalore[i] = new stone(ta, tb, tc, i);
  }
  coins = new coin[coinCount];
  for (int i = 0; i < coins.length; i++)
  {
    coins[i] =  new coin((int)(random(50, width - 50)), (int)(random(1000, 5000)), 1, i);
  }

  moles = new mole[moleCount];
  for (int i = 0; i < moleCount; i++)
  {
    moles[i] = new mole((int)(random(-500, width + 500)), (int)(random(4000, 9000)), i);
  }
  
  bullets = new bullet[10];
  for(int i = 0; i < bullets.length; i++)
  {
    bullets[i] = new bullet(-100, -100, 0, i, true);
  }
  
  bossing = false;
  
  bossAX = int(random(20, width - 20));
  bossAY = int(random(50000, 54000));
  bossAHealth = 80;
  chargeCooldown = 0;
  
  draculaX = int(random(20, width - 20));
  draculaY = 84000;
  draculaHealth = 200;
  if (developer)
  {
    balance = 1000000;
    invincible = 1000000000;
    scarfOn = true;
  } 
}

void draw()
{
  if (mode == 0)
  {
    background(134, 172, 245);
    dirt_texture();
    imageMode(CENTER);
    image(ostrich_look, width / 2, 220 - depth); 
    image(shop, width - 150, 270 - depth);
    textFont(stempel);
    textAlign(CENTER);
    fill(255);
    if(!developer)
    {
    text("A game made by Kevin De Keyser for Ludum Dare 29", width / 2, 50);
    }
    if(developer)
    {
      text("A game made by Kevin De Keyser for Ludum Dare 29 - DEV-Version", width / 2, 50);
    }
    fill(0);
    if (mouseY < 460 && mouseX > 720)
    {
      if (mousePressed)
      {
        mode = 4;
      }
    }
    if (frameCount % 20 < 10)
    {
      image(space, width / 2, 500);
    }

    if (keys[4] == true)
    {
      mode = 1;
    }
  }
  else if (mode == 1)
  {
    background(134, 172, 245);
    dirt_texture();
    imageMode(CENTER);
    image(ostrich_head, width / 2, 220 - depth); 
    image(shop, width - 150, 270 - depth);

    if (keys[4] == true)
    {
      mode = 1;
    }

    depth += 4;

    helmetEquipped = helmetOn;
    invincible = 0;
  }
  else if (mode == 2) //PLAY MODE !! MUSIC
  {
    background(134, 172, 245);
    dirt_texture();
    imageMode(CENTER);
    _head();
    _obstacles();
    _gui();

    if (invincible > 0)
    {
      invincible--;
    }

    if (weaponCooldown > 0 && samuraiOn == true)
    {
      weaponCooldown--;
    }
    else
    {
      keys[4] = false;
    }
    depth += 4;
  }
  else if (mode == 3)
  {
    _reset();
    mode = 0;
  }
  else if (mode == 4)
  {
    _shop();
  }

  if (shoutBoxCooldown > 0)
  {
    _shoutBox();
  }

  if (released && weaponSamurai)
  {
    if (bullets[cBullet].dead == true)
    {
      bullets[cBullet] = new bullet(2 + x, y + 55, (atan2(mouseY - (y + 55), mouseX - (x + 10))), cBullet, false);
      cBullet++;
      if (cBullet == 10)
      {
        cBullet = 9;
      }
    }
  }
  
  if(developer)
  {
    println(bossAY);
  }
  released = false;



  ellipseMode(CENTER);
  noFill();
  stroke(255);
  ellipse(mouseX, mouseY, 10, 10);
  line(mouseX + 5, mouseY + 5, mouseX - 5, mouseY - 5);
  line(mouseX + 5, mouseY - 5, mouseX - 5, mouseY + 5);
  stroke(0);
}

void _gui()
{
  fill(255);
  textAlign(LEFT);
  textFont(stempel);
  text("Meters: "+int(metres), width - 200, 30);
  text("Balance: "+int(balance)+"$", width - 200, 50);
  if (int(metres) == 9000)
  {
    message = "It's over 9000!!!!!!!";
    shoutBoxCooldown = 400;
  }

  String area = "Unknown";
  if (depth < 5000)
  {
    area = "Subsoil area";
  }
  else if (depth < 20000)
  {
    area = "Substratum area";
  }
  else if (depth < 50000)
  {
    area = "Bedrock";
  }
  else if (depth < 80000)
  {
    area = "Lithospere";
  }
  else if (depth >= 80000)
  {
    if (depth < 80008)
    {
      if (jsMode == true && javascript != null )
      {
        playSound1();
      }
    }

    area = "Asthenosphere";
    if (scarfOn == false)
    {
      message = "Died in lava.\nBuy the scarf\nto overcome\nthis problem.";
      shoutBoxCooldown = 400;
      mode = 3;
      if (jsMode == true && javascript != null )
      {
        playSound3();
      }
    }
  }
  text("Location: "+area, width - 200, 70);

  rectMode(CORNER);
  if (samuraiOn)
  {
    fill(255);
    rect(50, height - 70, 200 - (weaponCooldown * 2), 30);
    fill(0);
    textFont(stempel);
    textAlign(CENTER);
    text("Weapon Cooldown", 150, height - 50);
  }

  if (y < -200)
  {
    if (frameCount % 20 < 5) message = "Out of Bounds\nOstrich!";
    else if (frameCount % 20 < 10) message = "Don't think\noutside the\nbox!";
    else if (frameCount % 20 < 15) message = "The ostrich\ndidn't do\nwhat we want,\nso we\nsuffocated him.";
    else if (frameCount % 20 < 20) message = "You missed\nthe point of\nthis game.";
    shoutBoxCooldown = 400;
    mode = 3;
    if (jsMode == true && javascript != null )
    {
      playSound3();
    }
  }
  metres += 0.05;
}

class bullet
{
  int bulletX;
  int bulletY;
  float bulletAngle;
  int bullet_ID;
  boolean dead;
  bullet(int cx, int cy, float cangle, int cID, boolean cdead)
  {
    bulletX = cx;
    bulletY = cy;
    bulletAngle = cangle;
    bullet_ID = cID;
    dead = cdead;
  }

  void display()
  {
    if (dead == false)
    {
      fill(0);
      pushMatrix();
      translate(bulletX, bulletY);
      rotate(radians(bulletAngle));
      ellipseMode(CENTER);
      rect(0, 0, 10, 5, 3);
      popMatrix();
      bulletX = (int)(bulletX+cos(radians(bulletAngle * 50))*10);
      bulletY = (int)(bulletY+sin(radians(bulletAngle * 50))*10);

      for (int i = 0; i < moles.length; i++)
      {
        if (dist(bulletX, bulletY, moles[i].moleX, moles[i].moleY) < 60)
        {
          coins[0] = new coin((int)(random(moles[i].moleX - 150, moles[i].moleX + 150)), (int)(random(moles[i].moleY - 150, moles[i].moleY + 150)), coins[0].value, 0);
          coins[1] = new coin((int)(random(moles[i].moleX - 150, moles[i].moleX + 150)), (int)(random(moles[i].moleY - 150, moles[i].moleY + 150)), coins[1].value, 1);
          coins[2] = new coin((int)(random(moles[i].moleX - 150, moles[i].moleX + 150)), (int)(random(moles[i].moleY - 150, moles[i].moleY + 150)), coins[2].value, 2);
          coins[3] = new coin((int)(random(moles[i].moleX - 150, moles[i].moleX + 150)), (int)(random(moles[i].moleY - 150, moles[i].moleY + 150)), coins[3].value, 3);
          moles[moles[i].mole_ID] =  new mole((int)(random(-500, width + 500)), (int)(random(1000, 5000)), moles[i].mole_ID);
          dead = true;
        }
      }

      if (dist(bossAX+cos(radians(extraAngle * 50))*100, bossAY+sin(radians(extraAngle * 50))*100, bulletX, bulletY) < 200)
      {
        bossAHealth -= 2;
        dead = true;
      }
      if (bulletX > width || bulletX < 0 || bulletY < 0 || bulletY > height)
      {
        dead = true;
      }
      if (dist(draculaX, draculaY, bulletX, bulletY) < 70)
      {
        draculaHealth -= 2;
        dead = true;
      }
      if (draculaHealth == 0)
      {
        shoutBoxCooldown = 400;

        message = "You win\nGG!\nTake my\nmoney..\n\n\nNot that\ni'd have so\nmuch but it's\ndigital ^^";
        balance += 3000;
        mode = 3;
        if (jsMode == true && javascript != null )
      {
        playSound3();
      }
      }
      if (bulletX > width || bulletX < 0 || bulletY < 0 || bulletY > height)
      {
        dead = true;
      }
    }
  }
}

void keyPressed()
{
  if (jsMode)
  {
    if (key == int('w') || key == int('W') || keyCode == UP)
    {
      keys[0] = true;
    }
    else if (key == int('a') || key == int('A') || keyCode == LEFT)
    {
      keys[1] = true;
    }
    else if (key == int('s') || key == int('S') || keyCode == DOWN)
    {
      keys[2] = true;
    }
    else if (key == int('d') || key == int('D') || keyCode == RIGHT)
    {
      keys[3] = true;
    }
    else if (key == int(' '))
    {
      keys[4] = true;
      if(weaponCooldown == 0 && samuraiOn == true)
      {
        weaponCooldown = 100;
      }
    }
  }
  else
  {
    if (key == 'w' || key == 'W' || keyCode == UP)
    {
      keys[0] = true;
    }
    else if (key == 'a' || key == 'A' || keyCode == LEFT)
    {
      keys[1] = true;
    }
    else if (key == 's' || key == 'S' || keyCode == DOWN)
    {
      keys[2] = true;
    }
    else if (key == 'd' || key == 'D' || keyCode == RIGHT)
    {
      keys[3] = true;
    }
    else if (key == ' ')
    {
      keys[4] = true;
    }
  }
}

void keyReleased()
{
  if (jsMode)
  {
    if (key == int('w') || key == int('W') || keyCode == UP)
    {
      keys[0] = false;
    }
    else if (key == int('a') || key == int('A') || keyCode == LEFT)
    {
      keys[1] = false;
    }
    else if (key == int('s') || key == int('S') || keyCode == DOWN)
    {
      keys[2] = false;
    }
    else if (key == int('d') || key == int('D') || keyCode == RIGHT)
    {
      keys[3] = false;
    }
    else if (key == int(' '))
    {
      keys[4] = false;
    }
  }
  else
  {
    if (key == 'w' || key == 'W' || keyCode == UP)
    {
      keys[0] = false;
    }
    else if (key == 'a' || key == 'A' || keyCode == LEFT)
    {
      keys[1] = false;
    }
    else if (key == 's' || key == 'S' || keyCode == DOWN)
    {
      keys[2] = false;
    }
    else if (key == 'd' || key == 'D' || keyCode == RIGHT)
    {
      keys[3] = false;
    }
    else if (key == ' ')
    {
      keys[4] = false;
    }
  }
  if(key == 'v' && developer)
  {
    println("mouseX  "+ mouseX +"  mouseY " +mouseY);
  }
}



void mouseReleased()
{
  released = true;
}
void _obstacles()
{
    for (int i = 0; i < coins.length; i++)
    {
      coins[i].display();
    }
    for (int i = 0; i < stoneGalore.length; i++)
    {
      stoneGalore[i].display();
    }
    for (int i = 0; i < moles.length; i++)
    {
      moles[i].display();
    }
  
  for (int i = 0; i < bullets.length; i++)
  {
    bullets[i].display();
  }

  _bossA();
  _dracula();

  if (boulderDifficulty > 1400)
  {
    boulderDifficulty = (int)(5000 - (metres*5));
  }
}

class stone
{
  int stoneX;
  int stoneY;
  int stone_ID;
  int stone_type;
  stone(int cx, int cy, int ctype, int cID)
  {
    stoneX = cx;
    stoneY = cy;
    stone_ID = cID;
    stone_type = ctype;
    if (depth > 45000)
    {
      stone_ID = 0;
    }
  }

  void display()
  {
    stoneY -= 4;
    if (stoneY < height + 200)
    {
      if (stone_type == 0)
      {
        imageMode(CENTER);
        image(boulder, stoneX, stoneY);

        if (dist(stoneX, stoneY, x, y) < 85 && invincible == 0)
        {
          if (helmetEquipped)
          {
            helmetEquipped = false;
            invincible = 100;
          }
          else
          {
            if (frameCount % 20 < 5) message = "Stoned!\nNo pun\nintended.";
            else if (frameCount % 20 < 10) message = "You hit\nrock bottom!";
            else if (frameCount % 20 < 15) message = "I'm ashamed\nto say more\nbad jokes...";
            else if (frameCount % 20 < 20) message = "You got\nbouldered!";
            shoutBoxCooldown = 400;
            mode = 3;
            if (jsMode == true && javascript != null )
      {
        playSound3();
      }
          }
          //SOUND
        }
      }

      else if (stone_type == 1)
      {
        imageMode(CENTER);
        image(carton, stoneX, stoneY);

        if (dist(stoneX, stoneY, x, y) < 110 && invincible == 0) //CHANGE???
        {
          if (helmetEquipped)
          {
            helmetEquipped = false;
            invincible = 100;
          }
          else
          {
            if (frameCount % 20 < 5) message = "Crated!";
            else if (frameCount % 20 < 10) message = "I'm sure\nthe box\nloved you!";
            else if (frameCount % 20 < 15) message = "Seriously...\nYou got\nkilled by\na square...";
            else if (frameCount % 20 < 20) message = "Isn't brown\nattractive?";
            shoutBoxCooldown = 400;
            mode = 3;
            if (jsMode == true && javascript != null )
      {
        playSound3();
      }
          }
          //SOUND
        }
      }

      if (stoneY < -200)
      {
        stoneGalore[stone_ID] = new stone((int)(random(50, width - 50)), (int)(random(1000, boulderDifficulty)), (int)(random(0, 2)), stone_ID);
      }
    }
  }
}


class mole
{
  int moleX;
  int moleY;
  float moleAngle;
  int mole_ID;
  mole(int cX, int cY, int c_ID)
  {
    moleX = cX;
    moleY = cY;
    mole_ID = c_ID;
  }

  void display()
  {
    moleY -= 4;
    moleAngle = atan2(y - moleY, x - moleX);
    moleX = (int)(moleX+cos(radians(moleAngle * 50))*4);

    if (((moleX < 0 || moleX > width) &&(moleY < 0 || moleY > height)) == false)
    {
      moleY = (int)(moleY+sin(radians(moleAngle * 50))*3);
    }
    imageMode(CENTER);
    pushMatrix();
    translate(moleX, moleY);
    rotate(radians(moleAngle * 50) + 135);

    if (frameCount % 20 < 5)
    {
      image(mole1, 0, 0);
    }
    else if (frameCount % 20 < 10)
    {
      image(mole2, 0, 0);
    }
    else if (frameCount % 20 < 15)
    {
      image(mole3, 0, 0);
    }
    else if (frameCount % 20 < 20)
    {
      image(mole2, 0, 0);
    }
    popMatrix();

    if (dist(moleX, moleY, x, y) < 50 && invincible == 0) //CHANGE???
    {
      if (weaponCooldown > 70)
      {
        coins[0] = new coin((int)(random(moleX - 150, moleX + 150)), (int)(random(moleY - 150, moleY + 150)), coins[0].value, 0);
        coins[1] = new coin((int)(random(moleX - 150, moleX + 150)), (int)(random(moleY - 150, moleY + 150)), coins[1].value, 1);
        coins[2] = new coin((int)(random(moleX - 150, moleX + 150)), (int)(random(moleY - 150, moleY + 150)), coins[2].value, 2);
        coins[3] = new coin((int)(random(moleX - 150, moleX + 150)), (int)(random(moleY - 150, moleY + 150)), coins[3].value, 3);
        moles[mole_ID] =  new mole((int)(random(-500, width + 500)), (int)(random(1000, 5000)), mole_ID);
      }
      else {
        if (helmetEquipped)
        {
          helmetEquipped = false;
          invincible = 100;
          moles[mole_ID] =  new mole((int)(random(-500, width + 500)), (int)(random(1000, 5000)), mole_ID);
        }
        else
        {
          if (frameCount % 20 < 5) message = "Mole\nin one!!\n\n\nUhgghhh...\nBad Jokes...";
            else if (frameCount % 20 < 10) message = "Cute\nhe wanted\nto come\ncloser!\n\n\nAn then\nyou died.";
            else if (frameCount % 20 < 15) message = "Mole is sniffling.";
            else if (frameCount % 20 < 20) message = "Yeah..\nDied again.\nFrom an oversized\nMole.";
          shoutBoxCooldown = 200;
          mode = 3;
          if (jsMode == true && javascript != null )
      {
        playSound3();
      }
        }
      }
      //SOUND
    }


    if (moleY < -200)
    {
      moles[mole_ID] =  new mole((int)(random(-500, width + 500)), (int)(random(1000, 5000)), mole_ID);
    }
  }
}



int bossAX;
int bossAY;
int bossAHealth;
float bossAngle = 0;
int chargeCooldown;
float extraAngle = 0;


void _bossA()
{

  //charge Attack
  imageMode(CENTER);
  if (bossAHealth > 0)
  {
    if (bossAY < height + 300)
    {
      pushMatrix();
      translate(bossAX, bossAY);
      rotate(radians(bossAngle * 50) + 135);
      noTint();
      if ((chargeCooldown < 50) && frameCount % 10 < 5)
      {
        tint(255, 0, 0);
      }
      if (frameCount % 20 < 5) image(boss1, 0, 0);
      else if (frameCount % 20 < 10) image(boss2, 0, 0);
      else if (frameCount % 20 < 15) image(boss3, 0, 0);
      else if (frameCount % 20 < 20) image(boss4, 0, 0);
      noTint();
      popMatrix();

      for (int i = 0; i < stoneGalore.length; i++)
      {
        if (dist(bossAX, bossAY, stoneGalore[i].stoneX, stoneGalore[i].stoneY) < 150)
        {
          stoneGalore[i] = new stone((int)(random(50, width - 50)), (int)(random(1000, boulderDifficulty)), (int)(random(0, 2)), i);
        }
      }
      fill(255);
      rect((width / 2) - 100, height - 70, bossAHealth * 4, 30);
      fill(0);
      textFont(stempel);
      textAlign(CENTER);
      text("Health of the Driller: "+bossAHealth+ " / 50", (width / 2), height - 50);
      if (chargeCooldown < 1)
      {
        chargeCooldown = 500;
      }
      chargeCooldown--;
    }


    if ((dist(x, y, (int)(bossAX+cos(radians(bossAngle * 50))*100), (int)(bossAY+sin(radians(bossAngle * 100))*50)) < 120 && weaponCooldown < 50) || (weaponCooldown > 49 && dist(x, y, (int)(bossAX+cos(radians(bossAngle * 50))*100), (int)(bossAY+sin(radians(bossAngle * 100))*50)) < 70))
    {
      if (helmetEquipped)
      {
        helmetEquipped = false;
        invincible = 100;
      }
      else
      {
        message = "Wrecked\n\nBuy upgrades\nto win!!!";
        shoutBoxCooldown = 200;
        mode = 3;
        if (jsMode == true && javascript != null )
      {
        playSound3();
      }
      }
    }

    if (dist(bossAX+cos(radians(extraAngle * 50))*100, bossAY+sin(radians(extraAngle * 50))*100, x, y) < 200 && weaponCooldown > 70)
    {
      bossAHealth--;
    }



    if (bossAY > height- 20)
    {
      bossAY -= 4;
      chargeCooldown = 0;
    }
    else
    {
      if (chargeCooldown > 300)
      {
        if (((cos(radians(bossAngle * 50)) < 0 && bossAX < 20) || (cos(radians(bossAngle * 50)) > 0 && bossAX > width - 20)) == false) //IMPORTANT FIX
        {
          bossAX = (int)(bossAX+cos(radians(bossAngle * 50))*4);
        }
        if (((sin(radians(bossAngle * 50)) < 0 && bossAY < 20) || (sin(radians(bossAngle * 50)) > 0 && bossAY > width - 20)) == false)
        {
          bossAY = (int)(bossAY+sin(radians(bossAngle * 50))*4);
        }
      }
      else
      {
        if (chargeCooldown > 50)
        {
          bossAngle = atan2(y - bossAY, x - bossAX);
          extraAngle = atan2(bossAY - y, bossAX - x);
        }
      }
    }
  }
}





float draculaX;
float draculaY;
int flyToX = 500;
int flyToY = 500;
float draculaAngle = 0;
int flapCount = 0;
boolean flapDir = false;
int draculaCountdown = 0;
float draculaHealth;

void _dracula()
{
  if (draculaY < height + 300)
  {
    imageMode(CENTER);



    pushMatrix();
    translate(draculaX, draculaY);
    if (x > draculaX) scale(-1, 1);
    rotate(radians(flapCount));
    image(wing, 70, - 30);
    scale(-1, 1);
    rotate(radians(2 * flapCount));
    image(wing, 50, 0);
    popMatrix();
    pushMatrix();
    translate(draculaX, draculaY);
    if (x > draculaX) scale(-1, 1);
    image(dracula, 0, 0);

    popMatrix();

    if (draculaY < height - 50)
    {
      if (frameCount % 500 == 0)
      {
        draculaCountdown = 360;
        draculaAngle = int(atan2(draculaY - y, draculaX - x) * 50);
      }
    }
    if (draculaCountdown != 0)
    {
      draculaCountdown--; 
      draculaAngle++;

      strokeWeight(10);
      stroke(120, 0, 0);
      line(draculaX, draculaY, draculaX+cos(radians(draculaAngle))*10000, draculaY+sin(radians(draculaAngle))*10000);
      stroke(0);
      strokeWeight(1);


      if (dist(x, y, draculaX+cos(radians(draculaAngle))*dist(draculaX, draculaY, x, y), draculaY+sin(radians(draculaAngle))*dist(draculaX, draculaY, x, y)) < 20 && invincible < 1)
      {
        if (helmetEquipped)
        {
          helmetEquipped = false;
          invincible = 100;
        }
        else
        {
          message = "Tasered!";
          shoutBoxCooldown = 200;
          mode = 3;
          if (jsMode == true && javascript != null )
      {
        playSound3();
      }
        }
      }
    }

    draculaX = (draculaX+cos(radians(atan2(flyToY - draculaY, flyToX - draculaX) * 50))*5);
    draculaY = (draculaY+sin(radians(atan2(flyToY - draculaY, flyToX - draculaX) * 50))*5);
    if (dist(draculaX, draculaY, flyToX, flyToY) < 50)
    {
      flyToX = int(random(50, width - 50));
      flyToY = int(random(50, height - 50));
    }
      fill(255);
      rect((width / 2) - 100, height - 70, draculaHealth, 30);
      fill(0);
      textFont(stempel);
      textAlign(CENTER);
      text("Health of Shoopdracula: "+int(draculaHealth)+ " / 200", (width / 2), height - 50);
      
      
      if (dist(draculaX, draculaY, x, y) < 200 && weaponCooldown > 70)
    {
      bossAHealth -= 0.2;
    }

    if (flapCount > 45 || flapCount < -45)
    {
      flapDir = !flapDir;
    }
    if (flapDir) flapCount+=4;
    else {
      flapCount-=4;
    }
     
  }
  if (draculaY > height - 100)
  {
    draculaY -= 4;
  }
}

void _shop()
{
  background(134, 172, 245);
  imageMode(CENTER);
  image(ostrich_look, width / 2, 300);
  imageMode(CORNER);
  if (balance > 100 && helmetOn != true)
  {
    fill(0, 100, 255);
    if (mouseX > 20 && mouseY > 20 && mouseX < 120 && mouseY < 100)
    {
      fill(0, 255, 255);
      if (released)
      {
        balance -= 100;
        helmetOn = true;
      }
    }
  }
  else
  {
    fill(255, 0, 0);
  }
  rectMode(CORNER);
  rect(20, 20, 100, 80, 5);
  image(helmet, 20, 20); 
  fill(0);
  textAlign(CENTER);
  textFont(stempel);
  text("Military Helmet", 80, 120);
  if (helmetOn == false)
  {
    text("100$ - 2 lifes", 80, 140);
  }
  else
  {
    text("Sold", 80, 140);
  }



  if (balance > 800 && samuraiOn != true)
  {
    fill(0, 100, 255);
    if (mouseX > 20 && mouseX < 120 && mouseY > 140  && mouseY < 220)
    {
      fill(0, 255, 255);
      if (released)
      {
        balance -= 800;
        samuraiOn = true;
      }
    }
  }
  else
  {
    fill(255, 0, 0);
  }
  imageMode(CORNER);
  rect(20, 160, 100, 80, 5);
  pushMatrix();
  translate(50, 235);
  scale(1, -1);
  image(samurai, 0, 0);
  popMatrix(); 
  fill(0);
  textAlign(CENTER);
  textFont(stempel);
  text("Finest Samurai Blade", 80, 270);
  if (samuraiOn == false)
  {
    text("800$ - Hack n Slay", 80, 290);
  }
  else
  {
    text("Sold", 80, 290);
  }



  if (balance > 20000 && weaponSamurai != true && samuraiOn == true)
  {
    fill(0, 100, 255);
    if (mouseX > 20 && mouseX < 120 && mouseY > 300  && mouseY < 380)
    {
      fill(0, 255, 255);
      if (released)
      {
        balance -= 20000;
        weaponSamurai = true;
      }
    }
  }
  else
  {
    fill(255, 0, 0);
  }
  imageMode(CORNER);
  rect(20, 300, 100, 80, 5);
  pushMatrix();
  translate(50, 350);
  scale(1, -1);
  image(gun, 0, 0);
  popMatrix(); 
  strokeWeight(3);
  line(66, 344, 86, 324);
  strokeWeight(1);
  fill(0);
  textAlign(CENTER);
  textFont(stempel);
  text("Samurai 007", 80, 400);
  if (weaponSamurai == false)
  {
    text("20000$ - Shoot with samurai!", 115, 420);
  }
  else
  {
    text("Sold", 80, 420);
  }


  if (balance > 50000 && scarfOn == false)
  {
    fill(0, 100, 255);
    if (mouseX > 20 && mouseX < 120 && mouseY > 430  && mouseY < 510)
    {
      fill(0, 255, 255);
      if (released)
      {
        balance -= 50000;
        scarfOn = true;
      }
    }
  }
  else
  {
    fill(255, 0, 0);
  }
  imageMode(CORNER);
  rect(20, 430, 100, 80, 5);
  pushMatrix();
  translate(50, 450);
  scale(2);
  image(scarf_shop, 0, 0);
  popMatrix();
  fill(0);
  textAlign(CENTER);
  textFont(stempel);
  text("Worlds longest & most heat resistant scarf", 170, 530);
  if (scarfOn == false)
  {
    text("50000$ - Allows you to enter in the Asthenosphere!", 200, 550);
  }
  else
  {
    text("Sold", 80, 550);
  }

  textFont(font);
  textAlign(LEFT);
  text("Balance: "+balance+"$", width - 200, 50);
  fill(0, 100, 255);  
  if (mouseX > width - 170 && mouseY > height - 90)
  {
    fill(0, 255, 255);
    if (released)
    {
      mode = 0;
    }
  }
  rect(width - 170, height - 90, 150, 50, 5);
  textAlign(CENTER);
  fill(0);
  text("Return", width - 95, height - 60);
}


class coin
{
  int coinX;
  int coinY;
  int coin_ID;
  int value;
  coin(int cx, int cy, int cvalue, int cID)
  {
    coinX = cx;
    coinY = cy;
    coin_ID = cID;
    value = cvalue;
  }

  void display()
  {
    coinY -= 4;
    if (coinY < height + 200)
    {
      ellipseMode(CENTER);
      fill(0);
      textFont(stempel);
      if (value == 1)
      {
        fill(255, 255, 0);
      }
      else if (value == 2)
      {
        fill(#EABA40);
      }
      else if (value == 4)
      {
        fill(#40E6EA);
      }
      else if (value == 8)
      {
        fill(#F7BBA5);
      }
      else if (value == 16)
      {
        fill(#D6410B);
      }
      else if (value == 32)
      {
        fill(#7C0B74);
      }
      else if (value == 64)
      {
        fill(#25FF17);
      }
      else if (value == 128)
      {
        fill(#13891A);
      }
      else if (value == 256)
      {
        fill(#95969D);
      }
      else if (value > 256)
      {
        text(value+"$", coinX, coinY);
        fill(#FFFFFF);
      }

      if (value > 100)
      {
        ellipse(coinX, coinY, 50, 40);
      }
      else
      {
        ellipse(coinX, coinY, 30, 40);
      }
      fill(0);
      textAlign(CENTER);
      text(value+"$", coinX, coinY);

      if (coinY < -200)
      {
        coins[coin_ID] = new coin((int)(random(50, width - 50)), (int)(random(1000, 5000)), value * 2, coin_ID);
      }

      if (dist(coinX, coinY, x, y) < 50)
      {
        if (jsMode == true && javascript != null )
        {
          playSound2();
        }
        balance += value;

        if ((int)(random(0, 10)) == 5)
        {
          coins[coin_ID] = new coin((int)(random(50, width - 50)), (int)(random(1000, 5000)), value * 2, coin_ID);
        }
        else
        {
          coins[coin_ID] = new coin((int)(random(50, width - 50)), (int)(random(1000, 5000)), value, coin_ID);
        }
      }
    }
  }
}



void _shoutBox()
{
  textAlign(CENTER);
  textFont(font);
  fill(0);
  fill(frameCount % 255, frameCount % 255, (255 -frameCount) % 255);
  pushMatrix();
  translate(100, 100);
  scale(1+((frameCount % 50.0)/ 50.0));
  rotate(radians(315));
  text(message, 0, 0);
  popMatrix();
  shoutBoxCooldown--;
}

void _head()
{
  if (((cos(radians(angle)) < 0 && x < 20) || (cos(radians(angle)) > 0 && x > width - 20)) == false)
  {
    x = (int)(x+cos(radians(angle))*6);
  }
  y = (int)(y+sin(radians(angle))*6);
  if (y > height - 200)
  {
    y-=2;
  }
  y -= 4;
  if (keys[1] == true)
  {
    angle -= 2;
  }
  if (keys[3] == true)
  {
    angle += 2;
  }
  angle %= 360;
  imageMode(CORNER);

  if (neckCountMin > neckCountMax)
  {
    for (int i = 0; i < neckCountMax; i++)
    {
      pushMatrix();
      translate(neckX[i], neckY[i]);
      rotate(radians(neckAngle[i] + 270));
      if (scarfOn)
      {
        image(scarf, 0, 0);
      }
      else
      {
        image(neck, 0, 0);
      }
      popMatrix();
      neckY[i] -=4;
    }

    for (int i = neckCountMin; i < 500; i++)
    {
      pushMatrix();
      translate(neckX[i], neckY[i]);
      rotate(radians(neckAngle[i] + 270));
      if (scarfOn)
      {
        image(scarf, 0, 0);
      }
      else
      {
        image(neck, 0, 0);
      }
      popMatrix();
      neckY[i] -=4;
    }
  }
  for (int i = neckCountMin; i < neckCountMax; i++)
  {
    pushMatrix();
    translate(neckX[i], neckY[i]);
    rotate(radians(neckAngle[i] + 270));
    if (scarfOn)
    {
      image(scarf, 0, 0);
    }
    else
    {
      image(neck, 0, 0);
    }
    popMatrix();
    neckY[i] -=4;
  }


  neckX[(neckCountMax)%500] = x;
  neckY[(neckCountMax)%500] = y;
  neckAngle[(neckCountMax)%500] = (int)(angle);
  neckCountMax++;
  neckCountMin++;

  if (neckCountMax == 500)
  {
    neckCountMax = 0;
  }
  if (neckCountMin == 500)
  {
    neckCountMin = 0;
  }

  if ((invincible > 0 && frameCount % 10 < 5) || invincible == 0)
  {
    if (helmetEquipped == false)
    {
      pushMatrix();
      translate(x, y);
      rotate(radians(angle + 270));
      if (samuraiOn)
      {
        if (weaponCooldown > 70)
        {
          image(samurai, 10, 30);
        }
        else
        {
          image(samurai, 10, 10);
        }
      }
      image(head, 0, 0);
      if (weaponSamurai)
      {
        if (developer && keys[0] == true)
        {
          println("x: "+x +" y: "+y+ " px "+ mouseX+" py "+ mouseY);
        }
        translate(17, 30);
        strokeWeight(2);
        line(-15, 20, -15 + cos(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30, 20 + sin(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30);
        strokeWeight(1);
        rotate(radians(90));
        image(gun, 0, 0);
      }
      popMatrix();
    }
    else
    {
      pushMatrix();
      translate(x, y);
      rotate(radians(angle + 270));
      if (samuraiOn)
      {
        if (weaponCooldown > 70)
        {
          image(samurai, 10, 30);
        }
        else
        {
          image(samurai, 10, 10);
        }
      }
      image(head_military, 0, 0);
      if (weaponSamurai)
      {
        if (developer && keys[0] == true)
        {
          println("x: "+x +" y: "+y+ " px "+ mouseX+" py "+ mouseY);
        }
        translate(17, 30);
        strokeWeight(2);
        line(-15, 20, -15 + cos(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30, 20 + sin(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30);
        strokeWeight(1);
        rotate(radians(90));
        image(gun, 0, 0);
      }
      popMatrix();

      pushMatrix();
      translate(x, y);
      rotate(radians(angle + 270));
      if (samuraiOn)
      {
        if (weaponCooldown > 70)
        {
          image(samurai, 10, 30);
        }
        else
        {
          image(samurai, 10, 10);
        }
      }
      image(head_military, 0, 0);
      if (weaponSamurai)
      {
        if (developer && keys[0] == true)
        {
          println("x: "+x +" y: "+y+ " px "+ mouseX+" py "+ mouseY);
        }
        translate(17, 30);
        strokeWeight(2);
        line(-15, 20, -15 + cos(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30, 20 + sin(radians(atan2(mouseY - (y + 55), mouseX - (x + 10)) * 50))*30);
        strokeWeight(1);
        rotate(radians(90));
        image(gun, 0, 0);
      }
      popMatrix();
    }
  }
}



void dirt_texture()
{
  imageMode(CORNER);

  if (400 - depth > -400)
  {
    for (int j = 0; j < 8; j++)
    {
      for (int i = 0; i < 8; i++)
      {
        image(dirt, i * 128, (528 - depth) + (j * 128));
      }
    }
    for (int i = 0; i < 8; i++)
    {
      image(grass, i * 128, 400 - depth);
    }
    imageMode(CENTER);
    image(logo, width / 2, 800 - depth);
  }
  else
  {
    if (mode == 1) {
      x = width / 2;
      y = height / 4;
      angle = 90;
      mode = 2;
      if (jsMode == true && javascript != null )
      {
        playSound0();
      }
    }
    for (int j = 0; j < 8; j++)
    {
      if (depth + j * 64< 5000)
      {
        for (int i = 0; i < 8; i++)
        {

          image(dirt, i * 128, (j * 128) + (400 - depth) % 256);
        }
      }
      else if (depth + j *64 < 20000)
      {
        for (int i = 0; i < 8; i++)
        {

          image(dirt_stone, i * 128, (j * 128) + (400 - depth) % 256);
        }
      }
      else if (depth + j * 128 < 50000)
      {
        for (int i = 0; i < 8; i++)
        {
          image(stone_img, i * 128, (j * 128) + (400 - depth) % 256);
        }
      }
      else if (depth + j * 128 >= 50000 && depth + j * 128 <= 80000)
      {
        for (int i = 0; i < 8; i++)
        {
          image(lava_rock, i * 128, (j * 128) + (400 - depth) % 256);
        }
      }
      else if (depth + j * 128 > 80000)
      {
        for (int i = 0; i < 8; i++)
        {
          image(lava, i * 128, (j * 128) + (400 - depth) % 256);
        }
      }
    }
  }
}


